program Wybory;

const
 l_okr = 20;  {Liczba okrgw}
 l_kom = 6;   {Liczba komitetw}

 var
  wyn        : text;                                 {Plik z wynikami}
  glosy      : array[1..l_okr,1..l_kom] of integer;  {Liczby gosw oddanych w poszczeglnych okrgach}
  l_mandatow : array[1..l_okr] of integer;           {Liczby mandatw do rodzielenia w poszczeglnych okrgach} 
  mandat     : array[1..l_okr,1..l_kom] of integer;  {Liczby mandatw przydzielonych w poszczeglnych okrgach}
  komitety   : array[1..l_kom] of char;              {Nazwy poszczeglnych komitetw}

procedure wczytaj_dane; {Wczytanie danych do tablicy}
 var 
  nazwa_komitetu : char;
  dane           : text;      {Plik z danymi}
  i              : 1..l_okr;  {Indeks}
  j              : 1..l_kom;  {Indeks}
  k              : 0..l_kom;  {Indeks}
begin
  assign(dane, 'dane.txt');
  reset(dane);
  
  k := 0;
  for nazwa_komitetu:='A' to 'F' do
  begin
    k := k + 1;
    komitety[k] := nazwa_komitetu;
  end;
  
  for i := 1 to l_okr do
   begin
    for j := 1 to l_kom do 
      read(dane, glosy[i,j]);
    read(dane, l_mandatow[i]);
    readln(dane);
   end;
   
  close(dane);
end;

procedure mandaty;
 var 
  ktory   : integer;   {Ktry komitet ma dotd najwyszy wspczynnik v}
  max     : real;      {Ile wynosi dotd najwyszy wspczynnik v}
  v       : real;      {Warto wspczynnika v}
  i       : 1..l_okr;  {Indeks}
  j       : 1..l_kom;  {Indeks}
  k       : integer;   {Indeks} 

begin
  for i := 1 to l_okr do
    for j := 1 to l_kom do 
      mandat[i,j] := 0;
	  
  for i := 1 to l_okr do
   begin
    for k := 1 to l_mandatow[i] do {przydzielenie kolejnego mandatu}
     begin
       max   := 0;
       ktory := 1;
       for j := 1 to l_kom do 
        begin
         v := glosy[i,j] / (mandat[i,j]+1);
         if max < v then 
          begin
           max   := v;
           ktory := j;
          end;
        end; {for j}
      mandat[i,ktory] := mandat[i,ktory] + 1;
     end; {for k}
   end; {for i}
end; {mandaty}

procedure pkt1;
 var 
  suma : integer;   {Liczba gosw biecego komitetu}
  i    : 1..l_okr;  {Indeks}
  j    : 1..l_kom;  {Indeks}

begin
  writeln(wyn,'1');
  for j := 1 to l_kom do
   begin
    suma := 0;
    for i := 1 to l_okr do 
     suma := suma + glosy[i,j];
    writeln(wyn, komitety[j], '-', suma);
   end;
end;

procedure pkt2;
 var 
  suma      : integer;   {Liczba gosw w biecym  okrgu}
  max, min  : integer;   {Najwiksza i najmniejsza dotd liczba gosw w okrgu}
  ktory_min, 
  ktory_max : 0..l_okr;  {Numery okrgw o najmniejszej i najwikszej liczbie gosw} 
  i         : 1..l_okr;  {Indeks}
  j         : 1..l_kom;  {Indeks}
begin
  writeln(wyn, '2');
  max := 0; 
  min := maxint;
  ktory_min := 0; 
  ktory_max := 0;
  for i := 1 to l_okr do
  begin
    suma := 0;
    for j := 1 to l_kom do
      suma := suma + glosy[i,j];
    if suma > max then 
	 begin 
	  max := suma; 
	  ktory_max := i; 
	 end;
    if suma < min then 
	 begin 
	  min := suma; 
	  ktory_min := i; 
	 end;
  end;
  writeln(wyn, 'min: okreg nr ', ktory_min);
  writeln(wyn, 'max: okreg nr ', ktory_max);
end;

procedure pkt3;
 const
  nr_okr = 6; {Dla tego komitetu liczymy liczb mandatw}
 var
  j : 1..l_kom;  {Indeks}
begin
  writeln(wyn, '3');
  for j := 1 to l_kom do 
    writeln(wyn, komitety[j], '-', mandat[nr_okr,j]);
end;

procedure pkt4;
 var
  suma : integer;   {Liczba mandatw biecego komitetu}
  i    : 1..l_okr;  {Indeks}
  j    : 1..l_kom;  {Indeks}
begin
  writeln(wyn, '4');
  for j := 1 to l_kom do
   begin
    suma := 0;
    for i := 1 to l_okr do
      suma := suma + mandat[i,j];
    writeln(wyn, komitety[j], ' - ', suma);  
   end;
end;

begin {Program}
  wczytaj_dane;              {Wczytanie danych }
  
  mandaty;                   {Obliczenie liczby mandatw}  
  
  assign(wyn, 'wybory.txt'); {Utworzenie}
  rewrite(wyn);              {pliku wynikowego}
  
  {Wyznaczanie i zapisywanie odpowiedzi do poszczeglnych podpunktw}
  pkt1;
  pkt2;
  pkt3;
  pkt4;
  
  close(wyn);
end.
